/* eslint react/prop-types: [2, {ignore: ["container", "containerPadding", "target", "placement", "children"] }] */
/* These properties are validated in 'Portal' and 'Position' components */

'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utilsBootstrapUtils = require('./utils/bootstrapUtils');

var _utilsBootstrapUtils2 = _interopRequireDefault(_utilsBootstrapUtils);

var _Overlay = require('./Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _Popover = require('./Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var PopLayer = (function (_React$Component) {
  _inherits(PopLayer, _React$Component);

  function PopLayer() {
    _classCallCheck(this, PopLayer);

    _React$Component.apply(this, arguments);
  }

  PopLayer.prototype.render = function render() {
    var _props = this.props;
    var className = _props.className;
    var size = _props.size;
    var children = _props.children;
    var onSure = _props.onSure;
    var onClose = _props.onClose;

    return _react2['default'].createElement(
      _Overlay2['default'],
      _extends({}, this.props, {
        onHide: onClose
      }),
      _react2['default'].createElement(
        _Popover2['default'],
        { className: _classnames2['default'](className, _utilsBootstrapUtils2['default'].prefix(this.props, 'popover')) },
        _react2['default'].createElement(
          'div',
          { className: 'pt-content', style: size },
          children
        ),
        _react2['default'].createElement(
          'div',
          { className: 'pt-footer' },
          _react2['default'].createElement(
            'button',
            { onClick: onSure, className: 'ok' },
            '确定'
          ),
          _react2['default'].createElement(
            'button',
            { onClick: onClose, className: 'cancel' },
            '取消'
          )
        )
      )
    );
  };

  return PopLayer;
})(_react2['default'].Component);

PopLayer.propTypes = {
  /**
   * size 
   */
  size: _react2['default'].PropTypes.object,
  /**
   * 取消
   */
  onClose: _react2['default'].PropTypes.func,
  /**
   * 确定
   */
  onSure: _react2['default'].PropTypes.func
};
PopLayer.defaultProps = {
  size: { width: 300, height: 'atuo' },
  rootClose: true
};
exports['default'] = _utilsBootstrapUtils.bsClass('PopLayer', PopLayer);
module.exports = exports['default'];