'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _Object$is = require('babel-runtime/core-js/object/is')['default'];

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _OptionJs = require('./Option.js');

var _OptionJs2 = _interopRequireDefault(_OptionJs);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var Select = (function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select(props) {
    _classCallCheck(this, Select);

    _React$Component.call(this, props);
    this.loadData = [];
    this.state = {
      focus: -1,
      open: props.open,
      outMaxSelect: false,
      data: [],
      selected: [],
      selectedData: []
    };
    // 暴露的static 方法
    this.getSelected = this.getSelected.bind(this);
    this.getDatas = this.getDatas.bind(this);
    this.isSelectAll = this.isSelectAll.bind(this);
    this.getSelectedValue = this.getSelectedValue.bind(this);
    this.getSelectedText = this.getSelectedText.bind(this);
  }

  Select.prototype.componentWillMount = function componentWillMount() {
    this.initSelect(this.props);
  };

  Select.prototype.componentDidMount = function componentDidMount() {
    window.removeEventListener('click', this.globalMouseClick.bind(this), false);
    window.addEventListener('click', this.globalMouseClick.bind(this), false);
    this.refs.myselect.getElementsByClassName('myselect-body-scroll').scrollTop = 0;
  };

  Select.prototype.componentWillUnmount = function componentWillUnmount() {
    window.removeEventListener('click', this.globalMouseClick.bind(this));
  };

  Select.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps, nextState) {
    // 属性的改变目前只能引起 数值上的变化。
    var bool_value = false,
        bool_selected = false,
        tempValue = [];

    var _state = this.state;
    var selectedData = _state.selectedData;
    var selected = _state.selected;

    selectedData.forEach(function (item) {
      return tempValue.push(item.value);
    });

    var value = tempValue.length > 1 ? tempValue : tempValue[0];

    // value 相同的情况

    if (nextProps.value) {
      if (Array.isArray(value) && Array.isArray(nextProps.value)) {
        bool_value = !_Object$is(value.sort().toString(), nextProps.value.sort().toString());
      } else {
        bool_value = !_Object$is(value, nextProps.value);
      }
    }
    // selected 相同的情况
    if (nextProps.selected) {
      if (Array.isArray(selected) && Array.isArray(nextProps.selected)) {
        bool_selected = !_Object$is(selected.sort().toString(), nextProps.selected.sort().toString());
      } else {
        bool_selected = !_Object$is(selected, nextProps.selected);
      }
    }

    (bool_value || bool_selected) && this.changeText(nextProps);

    // 当再次接受到children时，进行更新
    if (nextProps.children) {
      if (!this.props.children) {
        this.initSelect(nextProps);
      } else {
        // 如果长度不一致，
        var __thisProps = this.chilrenToArray(this.props),
            __nextProps = this.chilrenToArray(nextProps);
        if (__thisProps.length !== __nextProps.length) {
          this.initSelect(nextProps);
        } else {
          // 长度一致则进行更深层比较
          var __thisValues = this.valueOfOptions(__thisProps),
              __nextValues = this.valueOfOptions(__nextProps);
          _Object$is(__thisValues.sort().toString(), __nextValues.sort().toString()) || this.initSelect(nextProps);
        }
      }
    } else {
      this.initSelect(nextProps);
    }
  };

  Select.prototype.render = function render() {
    var _classes;

    var _props = this.props;
    var disabled = _props.disabled;
    var style = _props.style;
    var width = _props.width;
    var value = _props.value;
    var selected = _props.selected;

    var otherProps = _objectWithoutProperties(_props, ['disabled', 'style', 'width', 'value', 'selected']);

    var classes = (_classes = {
      myselect: true
    }, _classes[otherProps.type] = true, _classes);
    // width 存在的情况下
    width && (style && style.width ? style.width = width : style = _Object$assign({}, { width: width }));
    return _react2['default'].createElement(
      'div',
      {
        style: style,
        ref: 'myselect',
        className: _classnames2['default'](classes, otherProps.className),
        onKeyDown: this.handleKeyDownOption.bind(this)
      },
      !!disabled ? this.renderDisabledHeader() : this.renderHeader(),
      _react2['default'].createElement(
        'div',
        { style: this.state.open && !disabled ? {} : { display: 'none' } },
        this.renderBody()
      )
    );
  };

  Select.prototype.renderDisabledHeader = function renderDisabledHeader() {
    var disabled = this.props.disabled;
    var text = this.state.text;

    return _react2['default'].createElement(
      'div',
      { className: _classnames2['default']("myselect-head", { disabled: disabled }) },
      _react2['default'].createElement(
        'div',
        { className: 'items' },
        text
      ),
      _react2['default'].createElement(
        'div',
        { className: 'dropdown-toggle' },
        _react2['default'].createElement('i', null)
      )
    );
  };

  Select.prototype.renderHeader = function renderHeader() {
    var _this = this;

    var _props2 = this.props;
    var type = _props2.type;
    var openSearch = _props2.openSearch;
    var showMultipleSize = _props2.showMultipleSize;
    var onClear = _props2.onClear;
    var text = this.state.text;

    var searchInput = function searchInput() {
      return _react2['default'].createElement(
        'div',
        { className: 'multiple-input-wrap' },
        _react2['default'].createElement('input', {
          type: 'text',
          className: 'search-input',
          value: text,
          title: text,
          onClick: _this.onHandClick.bind(_this),
          onChange: _this.onHandChange.bind(_this) }),
        !!onClear && text.length > 0 ? _react2['default'].createElement(
          'span',
          { className: 'Select-value-icon', onClick: _this.unSelectAll.bind(_this) },
          '×'
        ) : null
      );
    };
    var innerText = function innerText() {
      switch (type) {
        case 'single':
          return searchInput();
        case 'multiple':
          return (function () {
            if (openSearch) {
              var showText = text.length > 0 && showMultipleSize > -1 && text.length > showMultipleSize ? text.slice(0, showMultipleSize) + "..." : text;
              return _react2['default'].createElement(
                'div',
                { className: 'multiple-input-wrap' },
                _react2['default'].createElement('input', {
                  type: 'text',
                  className: 'search-input',
                  value: showText,
                  title: showText,
                  onClick: _this.onHandClick.bind(_this),
                  onChange: _this.onHandChange.bind(_this) }),
                !!onClear && text.length > 0 ? _react2['default'].createElement(
                  'span',
                  { className: 'Select-value-icon', onClick: _this.unSelectAll.bind(_this) },
                  '×'
                ) : null
              );
            }
          })();
      }
    };
    return _react2['default'].createElement(
      'div',
      { className: 'myselect-head', onClick: this.toggleMenu.bind(this) },
      _react2['default'].createElement(
        'div',
        { className: 'items', ref: 'multipleItem' },
        innerText()
      ),
      _react2['default'].createElement(
        'div',
        { className: 'dropdown-toggle', onClick: this.handleToggleMenu.bind(this) },
        _react2['default'].createElement('i', null)
      )
    );
  };

  Select.prototype.renderBody = function renderBody() {
    var _this2 = this;

    var _props3 = this.props;
    var type = _props3.type;
    var openSearch = _props3.openSearch;
    var hasIcon = _props3.hasIcon;
    var maxSelectedSize = _props3.maxSelectedSize;
    var maxHeight = _props3.maxHeight;
    var noSearchDataTips = _props3.noSearchDataTips;
    var showMultipleBar = _props3.showMultipleBar;
    var tooltip = _props3.tooltip;
    var _state2 = this.state;
    var data = _state2.data;
    var selectedData = _state2.selectedData;
    var text = _state2.text;
    var selected = _state2.selected;
    var outMaxSelect = _state2.outMaxSelect;
    var focus = _state2.focus;

    // 渲染主要区域
    var renderBodyMain = function renderBodyMain() {
      var unselectData = [],
          selecteds = [],
          text = [],
          newDatas = [];
      // 当为复选框，且开启搜索的时候
      if (type === "multiple" && openSearch) {
        (function () {
          var datas = [].concat(data);
          var selects = [];
          selectedData.forEach(function (item, index) {
            _this2.contains(data, item) && selects.push(item);
          });
          selects.forEach(function (item, index) {
            newDatas.push(item);
            selecteds.push(index);
            text.push(item.text);
            datas = datas.filter(function (data) {
              return item.value !== data.value;
            });
          });
          unselectData = datas;
          unselectData.forEach(function (item) {
            return newDatas.push(item);
          });
          data = newDatas;
          text = text;
          selected = selecteds;
        })();
      }
      return data.map(function (item, i) {
        var isSelect = false;
        'object' === typeof selected && selected.map(function (item) {
          return item == i && (isSelect = true);
        });
        return unselectData.length > 0 && selected.length != 0 && i == selected.length ? _react2['default'].createElement(
          'div',
          { key: i },
          _react2['default'].createElement('hr', null),
          _react2['default'].createElement(_OptionJs2['default'], {
            focused: focus == i ? true : false,
            item: item,
            selected: isSelect,
            index: i,
            hasIcon: hasIcon,
            type: type,
            tooltip: tooltip,
            selectItem: _this2.selectItem.bind(_this2, i) })
        ) : _react2['default'].createElement(_OptionJs2['default'], {
          key: i,
          focused: focus == i ? true : false,
          item: item,
          selected: isSelect,
          index: i,
          hasIcon: hasIcon,
          type: type,
          tooltip: tooltip,
          selectItem: _this2.selectItem.bind(_this2, i) });
      });
    };
    // 渲染操作栏目部分
    var renderBodyMG = function renderBodyMG() {
      return maxSelectedSize > -1 ? type == "multiple" && data.length > 0 && _react2['default'].createElement(
        'div',
        { className: 'myselect-opration' },
        '最多可选择（',
        _react2['default'].createElement(
          'em',
          { className: outMaxSelect ? "error" : "" },
          maxSelectedSize
        ),
        '）项'
      ) : showMultipleBar && type == "multiple" && data.length > 0 && _react2['default'].createElement(
        'div',
        { className: 'myselect-opration' },
        _react2['default'].createElement(
          'a',
          { href: 'javascript:;', onClick: _this2.selectAll.bind(_this2) },
          '全选'
        )
      );
    };
    return _react2['default'].createElement(
      'div',
      { className: 'myselect-body', style: { maxHeight: maxHeight }, ref: 'myselectBody' },
      _react2['default'].createElement(
        'div',
        { className: 'myselect-body-scroll' },
        renderBodyMG(),
        data.length > 0 ? renderBodyMain() : _react2['default'].createElement(
          'div',
          { className: 'no-data' },
          _react2['default'].createElement(
            'div',
            { className: 'text' },
            noSearchDataTips
          )
        )
      )
    );
  };

  Select.prototype.valueOfOptions = function valueOfOptions(options) {
    var values = [];
    Array.isArray(options) && options.forEach(function (option) {
      values.push(option.props.value);
    });
    return values;
  };

  Select.prototype.chilrenToArray = function chilrenToArray(props) {
    var children = [];
    if (props.children instanceof Array) {
      props.children.map(function (item) {
        item instanceof Array ? children = children.concat(item) : children.push(item);
      });
    } else {
      children.push(props.children);
    }
    return children;
  };

  // 初始化 select 。给定初始值

  Select.prototype.initSelect = function initSelect(props) {
    var _this3 = this;

    var value = [],
        text = [],
        selected = [];
    this.loadData = [];
    // 遍历 props.children , 给定选中值
    props.children && this.chilrenToArray(props).forEach(function (item, index) {
      var option = {
        value: item.props.value,
        text: item.props.children
      };
      // 将每项option 存入 loaddata
      _this3.loadData.push(option);
      // 优先selectAll -> 匹配value  , -> 匹配selected
      if (props.type === "multiple" && props.selectAll) {
        text.push(item.props.children);
        value.push(option);
        selected.push(index);
      } else if (props.value !== undefined) {
        var values = props.value;
        if ('string' === typeof values && values === item.props.value) {
          text.push(item.props.children);
          value.push(option);
          selected.push(index);
        } else if ('object' === typeof values && values.length > 0) {
          values.map(function (val) {
            if (val === item.props.value) {
              text.push(item.props.children);
              value.push(option);
              selected.push(index);
            }
          });
        }
      } else if (props.selected !== undefined) {
        var selects = props.selected;
        if ('number' === typeof selects && index === selects) {
          text.push(item.props.children);
          value.push(option);
          selected.push(index);
        } else if ('object' === typeof selects && selects.length > 0) {
          selects.map(function (select) {
            if (index === select) {
              text.push(item.props.children);
              value.push(option);
              selected.push(index);
            }
          });
        }
      } else {
        // 默认选择第一项
        if (props.type == "single" && props.selected == undefined) {
          text = [_this3.loadData[0].text];
          value = [_this3.loadData[0]];
          selected = [0];
        }
      }
    });

    this.setState({
      text: text,
      data: this.loadData,
      selected: selected,
      selectedData: value
    });
  };

  // 当select手动更改值。

  Select.prototype.changeText = function changeText(props) {
    var text = [],
        value = [],
        selected = [];
    this.loadData.forEach(function (option, index) {
      // 优先selectAll -> 匹配value  , -> 匹配selected
      if (props.type === "multiple" && props.selectAll) {
        text.push(option.text);
        value.push(option);
        selected.push(index);
      } else if (props.value !== undefined) {
        var values = props.value;
        if ('string' === typeof values && values === option.value) {
          text.push(option.text);
          value.push(option);
          selected.push(index);
        } else if ('object' === typeof values && values.length > 0) {
          values.map(function (val) {
            if (val === option.value) {
              text.push(option.text);
              value.push(option);
              selected.push(index);
            }
          });
        }
      } else if (props.selected !== undefined) {
        var selects = props.selected;
        if ('number' === typeof selects && index === selects) {
          text.push(option.text);
          value.push(option);
          selected.push(index);
        } else if ('object' === typeof selects && selects.length > 0) {
          selects.map(function (select) {
            if (index === select) {
              text.push(option.text);
              value.push(option);
              selected.push(index);
            }
          });
        }
      }
    });
    this.setState({
      text: text,
      selected: selected,
      selectedData: value
    });
  };

  // 是否包含

  Select.prototype.contains = function contains(array, item) {
    var bool = false;
    array.forEach(function (arr) {
      if (arr.value == item.value) return bool = true;
    });
    return bool;
  };

  Select.prototype.onHandChange = function onHandChange(e) {
    e.stopPropagation();
    this.props.openSearch && this.filterBySearch();
  };

  Select.prototype.onHandClick = function onHandClick(e) {
    var _this4 = this;

    e.stopPropagation();
    // 组织冒泡导致不可关闭
    _reactDom2['default'].findDOMNode(this.refs.myselectBody).click();
    var selects = [];var _state3 = this.state;
    var open = _state3.open;
    var selected = _state3.selected;
    var text = _state3.text;
    var data = _state3.data;
    var selectedData = _state3.selectedData;

    // 重置序列
    if (selectedData && selectedData.length > 0) {
      selectedData.forEach(function (select) {
        _this4.loadData.map(function (item, index) {
          select.value === item.value && selects.push(index);
        });
      });
    }

    if (!open) {
      if (!this.props.openSearch) {
        open = true;
        data = this.loadData;
        selected = selects;
      } else {
        open = true;
        text = [];
        data = this.loadData;
        selected = selects;
      }
    } else {
      if (this.props.openSearch && this.props.type === "multiple") {
        open = true;
        text = [];
        data = this.loadData;
        selected = selects;
      }
    }
    this.setState({
      open: open,
      text: text,
      selected: selected,
      data: data
    });
  };

  Select.prototype.filterBySearch = function filterBySearch() {
    var _this5 = this;

    var filter = this.refs.myselect.getElementsByClassName('search-input')[0].value;
    var data = [],
        selected = [];

    this.loadData.forEach(function (item, index) {
      item.text.toString().toLowerCase().indexOf(filter.toLowerCase()) > -1 && data.push(item);
    });

    // 重新匹配是否有选中
    switch (this.props.type) {
      case 'single':
        (function () {
          data.map(function (item, index) {
            if (_this5.state.selectedData && _this5.state.selectedData.length > 0) {
              _this5.state.selectedData[0].value === item.value && selected.push(index);
            }
          });
        })();break;
      case 'multiple':
        (function (item, index) {
          data.map(function (item, index) {
            if (_this5.state.selectedData && _this5.state.selectedData.length > 0) {
              // 序列重置
              _this5.state.selectedData.forEach(function (select) {
                select.value === item.value && selected.push(index);
              });
            }
          });
        })();break;
    }

    this.setState({
      text: [filter],
      data: data,
      focus: -1,
      selected: selected
    });
  };

  Select.prototype.toggleMenu = function toggleMenu() {
    // 组织冒泡导致不可关闭
    _reactDom2['default'].findDOMNode(this.refs.myselectBody).click();
    this.setState({
      open: !this.state.open
    });
  };

  // 手动点击关闭

  Select.prototype.handleToggleMenu = function handleToggleMenu(e) {
    var _this6 = this;

    e.stopPropagation();
    _reactDom2['default'].findDOMNode(this.refs.myselectBody).click();
    var type = this.props.type;
    var _state4 = this.state;
    var selectedData = _state4.selectedData;
    var open = _state4.open;

    var texts = [];
    switch (type) {
      case 'single':
        (function () {
          if (selectedData && selectedData.length > 0) {
            texts.push(selectedData[0].text);
          }
        })();break;
      case 'multiple':
        (function () {
          if (selectedData && selectedData.length > 0) {
            // 序列重置
            selectedData.forEach(function (select) {
              _this6.loadData.map(function (item, index) {
                if (select.value === item.value) {
                  texts.push(select.text);
                }
              });
            });
          }
        })();break;
    }
    this.setState({
      open: !open,
      text: open === true ? texts : []
    }, function () {
      open === false && _this6.refs.myselect.getElementsByClassName('search-input')[0].focus();
    });
  };

  Select.prototype.hasItemIndex = function hasItemIndex(item) {
    var index = -1;
    this.state.selectedData.forEach(function (select, i) {
      select.value == item.value && (index = i);
    });
    return index;
  };

  Select.prototype.selectItem = function selectItem(focusIndex, item) {
    var _this7 = this;

    var _props4 = this.props;
    var onSelected = _props4.onSelected;
    var maxSelectedSize = _props4.maxSelectedSize;

    // 失去焦点
    if (!item) {
      return false;
    }
    this.refs.myselect.getElementsByClassName('search-input')[0].blur();
    switch (this.props.type) {
      case 'single':
        (function () {
          _this7.setState({
            text: item.text,
            focus: focusIndex,
            selectedData: [item]
          }, function () {
            _this7.toggleMenu();
            onSelected && onSelected(item);
          });
        })();break;
      case 'multiple':
        (function () {
          var _state5 = _this7.state;
          var selectedData = _state5.selectedData;
          var data = _state5.data;
          var outMaxSelect = _state5.outMaxSelect;

          var itemIndex = _this7.hasItemIndex(item);
          var text = [],
              selected = [];
          // 如果已经被选中
          if (itemIndex > -1) {
            outMaxSelect = false;
            selectedData.splice(itemIndex, 1);
          } else {
            maxSelectedSize > -1 && selectedData.length === maxSelectedSize ? outMaxSelect = true : selectedData.push(item);
          }
          // 重新遍历data
          selectedData.forEach(function (select) {
            _this7.loadData.forEach(function (option, index) {
              option.value == select.value && text.push(select.text);
            });
          });
          selectedData.forEach(function (select) {
            data.forEach(function (option, index) {
              option.value == select.value && selected.push(index);
            });
          });
          _this7.setState({
            text: text,
            focus: focusIndex,
            outMaxSelect: outMaxSelect,
            selected: selected,
            selectedData: selectedData
          }, function () {
            onSelected && onSelected(selectedData);
          });
        })();break;
    }
  };

  Select.prototype.handleKeyDownOption = function handleKeyDownOption(e) {
    var _state6 = this.state;
    var focus = _state6.focus;
    var data = _state6.data;

    switch (e.keyCode) {
      // ESC
      case 27:
        this.handleToggleMenu(e);break;
      // enter
      case 13:
        focus > -1 && this.selectItem(focus, data[focus]);break;
      // up
      case 38:
        this.setState({
          focus: focus > 0 ? --focus : 0
        });this.controlScrolling();break;
      // down
      case 40:
        this.setState({
          focus: focus < data.length - 1 ? ++focus : data.length - 1
        });this.controlScrolling();break;
    }
  };

  Select.prototype.controlScrolling = function controlScrolling() {
    var _state7 = this.state;
    var focus = _state7.focus;
    var data = _state7.data;

    if (focus < 0 || focus >= data.length) {
      return false;
    }
    var mySelectBody = this.refs.myselect.getElementsByClassName('myselect-body')[0];
    var focusedItem = this.refs.myselect.getElementsByClassName('myselect-item')[focus];
    var specialClassElement = this.refs.myselect.getElementsByClassName('myselect-body-scroll')[0];

    var paddingTop = parseInt(mySelectBody.style.paddingTop);
    var paddingBottom = parseInt(mySelectBody.style.paddingBottom);

    paddingTop = paddingTop > -1 ? paddingTop : 0;
    paddingBottom = paddingBottom > -1 ? paddingBottom : 0;

    var windowHeight = mySelectBody.clientHeight - paddingTop - paddingBottom;
    var elementHeight = focusedItem.clientHeight;
    var elementOffsetTop = focusedItem.offsetTop - paddingTop;
    var elementCountPerWindow = Math.floor(windowHeight / elementHeight);
    var scrollTop = specialClassElement.scrollTop;

    if (elementOffsetTop > windowHeight + scrollTop - elementHeight) {
      mySelectBody.scrollTop = elementOffsetTop - (elementCountPerWindow - 1) * elementHeight;
    } else if (elementOffsetTop < scrollTop) {
      mySelectBody.scrollTop = elementOffsetTop;
    } else if (focus == 0) {
      mySelectBody.scrollTop = 0;
    }
  };

  Select.prototype.removeItem = function removeItem(index, e) {
    var _this8 = this;

    e.stopPropagation();
    var _state8 = this.state;
    var selected = _state8.selected;
    var selectedData = _state8.selectedData;var texts = this.state.text;
    if (index || index == 0) {
      texts.splice(index, 1);
      selected.splice(index, 1);
      selectedData.splice(index, 1);
    }
    this.setState({
      text: texts,
      selected: selected,
      selectedData: selectedData
    }, function () {
      _this8.props.onSelected && _this8.props.onSelected(selectedData);
    });
  };

  Select.prototype.globalMouseClick = function globalMouseClick(event) {
    var _this9 = this;

    if (!this.refs.myselect) {
      return;
    }
    var target = event.target || event.srcElement,
        inHead = this.closest(target, "myselect-head"),
        inBody = this.closest(target, "myselect-body");
    if (!inHead && !inBody) {
      (function () {
        var _state9 = _this9.state;
        var text = _state9.text;
        var data = _state9.data;
        var selected = _state9.selected;
        var open = _state9.open;
        var selectedData = _state9.selectedData;var selects = [];var texts = [];
        /*if (!this.props.openSearch) {
          return ;
        }*/
        switch (_this9.props.type) {
          case 'single':
            (function () {
              if (selectedData && selectedData.length > 0) {
                texts.push(selectedData[0].text);
                // 序列重置
                _this9.loadData.map(function (item, index) {
                  if (selectedData[0].value === item.value) selects.push(index);
                });

                text = texts;
                data = _this9.loadData;
                selected = selects;
              }
            })();break;
          case 'multiple':
            (function () {
              if (selectedData && selectedData.length > 0) {
                // 序列重置
                selectedData.forEach(function (select) {
                  _this9.loadData.map(function (item, index) {
                    if (select.value === item.value) {
                      selects.push(index);
                      texts.push(select.text);
                    }
                  });
                });

                text = texts;
                data = _this9.loadData;
                selected = selects;
              }
            })();break;
        }
        _this9.setState({
          open: false,
          text: text,
          data: data,
          selected: selected
        });
      })();
    }
  };

  Select.prototype.closest = function closest(target, className) {
    if (target && (target.nodeName.toLowerCase() === "body" || target.nodeName.toLowerCase() === "svg" || "string" === typeof target.className && target.className.indexOf(className) > -1)) {
      return false;
    } else if (!target) {
      return true;
    }
    return target.parentElement && target.parentElement.className && 'string' === typeof target.parentElement.className && target.parentElement.className.indexOf(className) > -1 ? true : this.closest(target.parentElement, className);
  };

  Select.prototype.selectAll = function selectAll(e) {
    e.stopPropagation();
    var text = [],
        selected = [];

    this.state.data.length > 0 && this.state.data.forEach(function (item, index) {
      text.push(item.text);
      selected.push(index);
    });

    this.setState({
      text: text,
      focus: -1,
      selected: selected,
      selectedData: this.state.data
    });
  };

  Select.prototype.unSelectAll = function unSelectAll(e) {
    var _this10 = this;

    e.stopPropagation();
    this.setState({
      text: [],
      focus: -1,
      selected: [],
      selectedData: []
    }, function () {
      //如果没有此回调，在调用后的数据不清空，state 状态更新依旧会存在数据
      _this10.props.onClear && 'function' === typeof _this10.props.onClear && _this10.props.onClear();
    });
  };

  // isSelectAll 是否选中

  Select.prototype.isSelectAll = function isSelectAll() {
    return this.state.data.length === this.state.selectedData.length;
  };

  // 获取 getDatas

  Select.prototype.getDatas = function getDatas() {
    return this.state.data;
  };

  // 获取选中的对象

  Select.prototype.getSelected = function getSelected() {
    return this.state.selectedData;
  };

  // 获取选中的value 值

  Select.prototype.getSelectedValue = function getSelectedValue() {
    var value = [];
    this.state.selectedData.forEach(function (item) {
      return value.push(item.value);
    });
    return value;
  };

  // 获取选中的文本内容

  Select.prototype.getSelectedText = function getSelectedText() {
    var text = [];
    this.state.selectedData.forEach(function (item) {
      return text.push(item.text);
    });
    return text;
  };

  return Select;
})(_react2['default'].Component);

Select.propTypes = {
  /**
   * 最大高度，超过出现滚动条
   * {number}
   */
  maxHeight: _react2['default'].PropTypes.number,
  /**
   * 宽度
   * {number|string}
   */
  width: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.number]),
  /**
   * 是否开启搜索
   * {boolean}
   */
  openSearch: _react2['default'].PropTypes.bool,
  /**
   * select 类型 ， single -> 单选(默认)，multiple -> 复选
   * {[type]}
   */
  type: _react2['default'].PropTypes.oneOf(["single", "multiple"]),
  /**
   * onSelect 选中事件
   */
  onSelected: _react2['default'].PropTypes.func,
  /**
   * onClear 清除已选内容事件, 如果是通过OnSelected 去取值的话，清空后的数据，需要通过onClear去清楚
   */
  onClear: _react2['default'].PropTypes.func,
  /**
   * 设置选中序列号
   * {number | array}
   */
  selected: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.array, _react2['default'].PropTypes.number]),
  /**
   * 设置所选中的值
   * {string | array}
   */
  value: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.array, _react2['default'].PropTypes.string]),
  /**
   * @private
   * 禁用
   */
  disabled: _react2['default'].PropTypes.bool,
  /**
   * 是否显示图标
   * {Boolean}
   */
  hasIcon: _react2['default'].PropTypes.bool,
  /**
   * 是否打开
   * {Boolean}
   */
  open: _react2['default'].PropTypes.bool,
  /**
   * 是否选中全部
   * {boolean}
   */
  selectAll: _react2['default'].PropTypes.bool,
  /**
   * 搜索开启，无查找内容提示语
   * {string}
   */
  noSearchDataTips: _react2['default'].PropTypes.string,
  /**
   * 复选显示在输入框size
   * {number}
   */
  showMultipleSize: _react2['default'].PropTypes.number,
  /**
   * 复选情况下是否显示 全选
   * @type {boolean}
   */
  showMultipleBar: _react2['default'].PropTypes.bool,
  /**
   * 复选框最多选中的项数，配置此属性，则showMultipleBar失效
   * {number}
   */
  maxSelectedSize: _react2['default'].PropTypes.number,
  /**
   * 选项提示信息
   * @type {Object}
   */
  tooltip: _react2['default'].PropTypes.shape({
    show: _react2['default'].PropTypes.bool,
    placement: _react2['default'].PropTypes.oneOf(["left", "right", "top", "bottom"])
  })
};

Select.defaultProps = {
  open: false,
  noSearchDataTips: '没有找到相关数据',
  hasIcon: false,
  selectAll: false,
  type: "single",
  showMultipleSize: -1, // 不限
  maxHeight: 180,
  openSearch: false,
  showMultipleBar: true,
  maxSelectedSize: -1, // 不限
  tooltip: {
    show: false,
    placement: 'left'
  }
};

exports['default'] = Select;
module.exports = exports['default'];